#include "stdafx.h"
#include <shellapi.h>
#include <atlstr.h>
#include "const.h"
#include "LauncherManager.h"

BOOL WaitForHandleTipLauncher( HANDLE handle, int timeout )
{
	DWORD ret;
	int check_heartbeat = 0;
	BOOL bContinue = true;
	do{		
		ret = ::WaitForSingleObject( handle, timeout );
		switch( ret )
		{
		case WAIT_OBJECT_0:
			bContinue = false;
			break;

		case WAIT_TIMEOUT:
			if( FALSE == CheckTipLauncher() )
			{
				check_heartbeat++;
				if( check_heartbeat > 5 )
					return FALSE;
			}

			continue;
			break;

		default:
			return FALSE;
			break;
		}
	}while(bContinue);

	return TRUE;
}

BOOL CheckTipLauncher()
{
	IIPCHandle* launcherHandle = LauncherManager::GetInstance()->GetLauncherHandle();
	if( NULL == launcherHandle )
		return FALSE;

	return TRUE;
}

HANDLE ExecuteProgram( const TCHAR *path, const TCHAR *para )
{
	SHELLEXECUTEINFO sei = { sizeof(sei) };
	sei.fMask = SEE_MASK_NOCLOSEPROCESS;
	sei.nShow = SW_SHOWNORMAL; // added 27 Nov
	sei.lpVerb = _T("open");
	sei.lpFile = path;
	sei.lpParameters = para;
	if( FALSE == ShellExecuteEx(&sei) )
		return NULL;

	return sei.hProcess;
}

BOOL ExecProgram(const TCHAR *path, const TCHAR *para)
{
	SHELLEXECUTEINFO sei = { sizeof(sei) };
	sei.fMask = SEE_MASK_NOCLOSEPROCESS;
	sei.nShow = SW_SHOWNORMAL; // added 27 Nov
	sei.lpVerb = _T("open");
	sei.lpFile = path;
	sei.lpParameters = para;
	return ShellExecuteEx(&sei);
}

BOOL ExecProgram(const CString szStrCommand)
{
	CString szStrCmd, szStrParam;

	szStrCmd = szStrCommand;
	szStrParam = _T("");

	TCHAR val = szStrCommand.GetAt(0);

	if ( (val=='"') || (val=='\''))
	{
		int epos = szStrCommand.Find(val, 1);
		if (epos>=0)
		{
			szStrCmd = szStrCommand.Mid(1, epos-1);
			szStrParam = szStrCommand.Mid(epos+2);
		}
	}

	return ExecProgram( szStrCmd, szStrParam );
}

BOOL GetFileNameInPath( const TCHAR *path, TCHAR *filename, int size)
{
	TCHAR *pathdata = (TCHAR *)path;
	int len = lstrlen(pathdata);
	while( len > 0 )
	{
		if( '\\' == pathdata[len-1] )
			break;

		len--;
	}

	if( 0 == len )
		return FALSE;

	ATL::Checked::tcscpy_s( filename, size, &pathdata[len] );
	return TRUE;
}

BOOL MyPostMessage(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	BOOL bRet = FALSE;
	for( int retry_count = 0; retry_count < RETRY_COUNT_FOR_POST_MESSAGE; retry_count++ )
	{
		bRet = ::PostMessage( hWnd, msg, wParam, lParam );
		if( TRUE == bRet )
			break;
	}

	return bRet;
}